require "import"
import "androlua.*"
import "luajava.*"

local prev = nil -- To track the last number clicked

-- Function to pick a random number with advanced logic
function getRandomNumber()
    local rand = math.random()
    local min, max, number

    -- Decide behavior dynamically
    if rand < 0.2 then
        min, max = 0, 6 -- Full range
    elseif rand < 0.4 then
        min, max = 2, 6 -- Narrower range
    elseif rand < 0.6 then
        min, max = 3, 5 -- Tighter range
    elseif rand < 0.8 then
        number = math.random(3, 5) -- Pick a single number between 3 and 5
    else
        local pair = {{6, 4}, {4, 2}, {6, 2}} -- Fixed unpredictable pairs
        local choice = pair[math.random(#pair)]
        number = choice[math.random(2)] -- Pick from the pair
    end

    -- Generate the number if not pre-decided
    if not number then
        number = math.floor(Math.random() * (max - min + 1) + min)
    end

    -- Avoid repeating the same number too often
    if number == prev and math.random() < 0.8 then
        return getRandomNumber() -- Recursive call for a fresh number
    end

    prev = number -- Update previous number
    return number
end

-- Main script
local r = getRandomNumber()
local s = "" .. r
if service.click({{s,}})
    return true
end